function setupWebViewJavascriptBridge(callback) {
    if (window.WebViewJavascriptBridge) {
        return callback(WebViewJavascriptBridge);
    }
    if (window.WVJBCallbacks) {
        return window.WVJBCallbacks.push(callback);
    }
    window.WVJBCallbacks = [callback];
    var WVJBIframe = document.createElement('iframe');
    WVJBIframe.style.display = 'none';
    WVJBIframe.src = 'https://__bridge_loaded__';
    document.documentElement.appendChild(WVJBIframe);
    setTimeout(function () {
        document.documentElement.removeChild(WVJBIframe)
    }, 0)
}


setupWebViewJavascriptBridge(function (bridge) {
})


/**
 * 打开本地图片入口
 *
 * @param index
 * @param urls
 */
function openLocalImage(index, urls) {
    var client = getClient() || 'Android';
    if (client == 'IOS') {
        window.WebViewJavascriptBridge.callHandler('openImage', {'index': index, 'urls': urls}, function (response) {
            log('JS got response', response)
        })
    } else {
        Android.openImage(index, urls);
    }
}

/**
 * 关闭当前页面
 */
function finishCurrentActivity() {
    Android.finishCurrentActivity();
}

function gotoBranchDetail() {
    Android.gotoBranchDetail();
}

getClient = function () {
    var userAgent = navigator.userAgent || navigator.vendor || window.opera;
    if (/Android/i.test(userAgent)) {
        return 'Android';
    } else if (/iPhone|iPad|iPod/i.test(userAgent)) {
        return 'IOS';
    } else if (/IEMobile/i.test(userAgent)) {
        return 'Windows';
    } else if (/BlackBerry/i.test(userAgent)) {
        return 'BlackBerry';
    }
    ;
}