package com.dh.DpsdkCore;

public class IDpsdkCore 
{
    static {
    	try
    	{
    		System.loadLibrary("gnustl_shared");
    		System.loadLibrary("dhDpsdkCore");
    	}
		catch(UnsatisfiedLinkError ulink)
		{    
	        ulink.printStackTrace();   
		}  
    }

   	
    /************************************************************************
     ** 接口定义
     ***********************************************************************/
	/** 创建SDK句柄.
	 @param   IN	nType			SDK类型
	 @param   OUT	nDllHandle		返回SDK句柄，后续操作需要以此作为参数
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark									
	*/
	static public native  int	DPSDK_Create(int nType, Return_Value_Info_t nDllHandle);
	
	/** 删除SDK句柄.
	 @param   IN	nPDLLHandle		SDK句柄
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	 1、需要和DPSDK_Create成对使用
	*/
	static public native  int	DPSDK_Destroy( int nPDLLHandle );
	
	/** 获取错误码信息.
	*/
//	static public native  int	DpsdkGetLastError();
	
	/** 设置日志.
	 @param   IN	szFilename		文件名称
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark									
	*/
	static public native int DPSDK_SetLog(int nPDLLHandle, byte szFilename[]);

	/** 设置DPSDK状态回调.
	 @param   IN	nPDLLHandle				SDK句柄
	 @param   IN	statusCallback			回调函数
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	*/
	static public native int DPSDK_SetDPSDKStatusCallback( int nPDLLHandle, fDPSDKStatusCallback statusCallback);

	/** 设置DPSDK设备变更回调.
	 @param   IN	nPDLLHandle				SDK句柄
	 @param   IN	deviceChangeCallback	回调函数
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	*/
	static public native int DPSDK_SetDPSDKDeviceChangeCallback(int nPDLLHandle, fDPSDKDeviceChangeCallback deviceChangeCallback);
	
	/** 设置DPSDK新组织设备变更回调
	 @param   IN	nPDLLHandle				SDK句柄
	 @param   IN	orgDevChangeNewCallback	回调函数
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	*/
	static public native int DPSDK_SetDPSDKOrgDevChangeNewCallback(int nPDLLHandle, fDPSDKOrgDevChangeNewCallback orgDevChangeNewCallback);

	/** 设置DPSDK设备状态回调.
	 @param   IN	nPDLLHandle					SDK句柄
	 @param   IN	deviceStatusCallback		回调函数
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	*/
	static public native int DPSDK_SetDPSDKDeviceStatusCallback(int nPDLLHandle, fDPSDKDevStatusCallback deviceStatusCallback);
	
	/** 设置报警状态回调.
	 @param   IN	nPDLLHandle					SDK句柄
	 @param   IN	alarmCallback				回调函数
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
		1、需要和DPSDK_Create成对使用
	*/
	static public native int DPSDK_SetDPSDKAlarmCallback(int nPDLLHandle, fDPSDKAlarmCallback alarmCallback);

	
	/** 注册平台.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	loginInfo		用户登录信息
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native  int  DPSDK_Login( int nPDLLHandle, Login_Info_t loginInfo, int nTimeout);
	
	/** 登出平台.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native  int  DPSDK_Logout( int nPDLLHandle, int nTimeout);

	/** 重新连接CMS.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native  int  DPSDK_ReconnectToCMS( int nPDLLHandle, int nTimeout);
	
	/** 获取用户Id.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	nUserId			用户Id
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native  int DPSDK_GetUserID( int nPDLLHandle,  Return_Value_Info_t nUserId);

	/** 更改用户密码.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	szOldPsw		原有密码
	 @param   IN	szNewPsw		新密码
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native  int DPSDK_ChangeUserPassword( int nPDLLHandle, byte szOldPsw[], byte szNewPsw[], int nTimeout);

	/** 获取用户等级.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	nUserLevel		用户等级
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native  int DPSDK_GetUserLevel( int nPDLLHandle, Return_Value_Info_t nUserLevel );
	
	/** 获取电子地图服务配置信息
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	mapAddrInfo		电子地图服务配置信息
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native  int DPSDK_GetMapAddrInfo( int nPDLLHandle, Config_Emap_Addr_Info_t mapAddrInfo, int nTimeout);

	/** 获取组织结构时，设置是否采用压缩格式获取.
	 @param   IN	nPDLLHandle			SDK句柄
	 @param   IN	nCompressType		是否采用压缩格式,参考dpsdk_get_devinfo_compress_type_e
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark									
	*/
	static public native  int DPSDK_SetCompressType( int nPDLLHandle, int nCompressType);
	
	/** 加载组织设备信息.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   OUT	nGroupLen       组织结构信息长度
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native  int DPSDK_LoadDGroupInfo( int nPDLLHandle, Return_Value_Info_t nGroupLen, int nTimeout );

	/** 加载特定类型组织信息.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN    type            通用节点类型
	 @param   OUT	nOrgCount       返回组织信息的数量
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native  int DPSDK_LoadOrgInfoByType( int nPDLLHandle, int type, Return_Value_Info_t nOrgCount, int nTimeout );

	/** 分级加载组织设备信息.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	depInfo			分级获取的节点信息 
	 @param   OUT	nGroupLen       组织结构信息长度
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native  int  DPSDK_LoadDGroupInfoLayered( int nPDLLHandle, Load_Dep_Info_t depInfo, Return_Value_Info_t nGroupLen, int nTimeout );
	
	/** 获取组织设备信息串.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   OUT	szGroupBuf		组织结构缓存,需要外部创建缓存，大小为nGroupLen+1
	 @param   IN	nGroupLen       组织结构信息长度
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	 1、szGroupBuf需要在外面创建好
	 2、szGroupBuf的大小与nGroupLen需要一致或者大于nGroupLen
	*/
	static public native  int DPSDK_GetDGroupStr( int nPDLLHandle, byte szGroupBuf[], int nGroupLen, int nTimeout );

	/** 获取分级加载的组织设备信息串.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   OUT	szGroupBuf		组织结构缓存,需要外部创建缓存，大小为nGroupLen+1
	 @param   IN	nGroupLen       组织结构信息长度
	 @param   IN	szCoding		节点code
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	 1、szGroupBuf需要在外面创建好
	 2、szGroupBuf的大小与nGroupLen需要一致或者大于nGroupLen
	*/
	static public native  int DPSDK_GetDGroupLayeredStr( int nPDLLHandle, byte szGroupBuf[], int nGroupLen, byte szCoding[], int nTimeout );
																   
	/** 获取根节点信息.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   OUT	getInfo			根节点信息
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	*/
	static public native  int DPSDK_GetDGroupRootInfo(int nPDLLHandle,Dep_Info_t getInfo );

	/** 获取组织下子组织和子设备的个数.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   INOUT	getInfo			获取组织个数请求信息
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	*/
	static public native  int DPSDK_GetDGroupCount( int nPDLLHandle, Get_Dep_Count_Info_t getInfo );

	/** 获取组织下子组织和子设备的信息.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   INOUT	getInfo			子组织子设备信息
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	 1、pDepInfo、pDeviceInfo需要在外面创建好
	 2、pDepInfo、pDeviceInfo的大小与DPSDK_GetDGroupCount返回需要一致
	 */
	static public native  int DPSDK_GetDGroupInfo( int nPDLLHandle, Get_Dep_Info_t getInfo );

	/** 获取设备下子通道的信息.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   INOUT	getInfo			子通道信息
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	 1、pEncChannelnfo需要在外面创建好
	 2、pEncChannelnfo的大小与DPSDK_GetDGroupInfo中通道个数返回需要一致
	 */
	static public native  int DPSDK_GetChannelInfo( int nPDLLHandle, Get_Channel_Info_t getInfo );

	/** 获取设备下子通道的信息(扩展).
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   INOUT	getInfo			子通道信息
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	 1、pEncChannelnfo需要在外面创建好
	 2、pEncChannelnfo的大小与DPSDK_GetDGroupInfo中通道个数返回需要一致
	 */
	static public native  int DPSDK_GetChannelInfoEx( int nPDLLHandle, Get_Channel_Info_Ex_t getInfo );

	/** 获取设备下子通道(编码通道)的个数
	 @param   IN	nPDLLHandle			SDK句柄
	 @param   IN	szDeviceId			设备ID
	 @param   OUT	nEncChannelCount	编码通道个数
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	 */
	static public native  int DPSDK_GetEncChannelCount( int nPDLLHandle, byte szDeviceId[], Return_Value_Info_t nEncChannelCount);
	
	/** 获取设备支持的码流类型.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   INOUT	getInfo			获取信息
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	 */
	static public native  int DPSDK_GetDevStreamType( int nPDLLHandle, Get_Dev_StreamType_Info_t getInfo );

	/** 获取通道类型
	 @param   IN	nPDLLHandle			SDK句柄
	 @param   IN	szCameraId			设备ID
	 @param   OUT	nUnitType			通道类型,参考dpsdk_dev_unit_type_e
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	 */
	static public native  int DPSDK_GetChnlType( int nPDLLHandle, byte szCameraId[], Return_Value_Info_t nUnitType);	

	/** 根据CemeraId获取通道信息
	@param   IN    nPDLLHandle     SDK句柄
	@param   IN    szCameraId      通道ID
	@param   OUT   pChannelInfo    通道信息，参见Enc_Channel_Info_Ex_t
	@return  函数返回错误类型，参考dpsdk_retval_e
	@remark 
	*/
	static public native  int   DPSDK_GetChannelInfoById(int nPDLLHanle, byte szCameraId[], Enc_Channel_Info_Ex_t ChannelInfo);
	
  	/** 是否有业务树
	 @param   IN	nPDLLHandle		SDK句柄
	 @return  函数返回true表示含有业务树，否则表示没有业务树
	 @remark
	*/
	static public native boolean DPSDK_HasLogicOrg(int nPDLLHandle);	

	/** 获取业务树根节点信息.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   OUT	depInfoEx		业务树根节点信息
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	*/
	static public native  int DPSDK_GetLogicRootDepInfo(int nPDLLHandle,Dep_Info_Ex_t depInfoEx );

	/** 获取业务树指定节点下 节点/通道/设备的数目
	 @param   IN	nPDLLHandle						SDK句柄
	 @param   IN    szDepCoding						节点Coding
	 @param   IN    nNodeType						组织/通道/设备,参考dpsdk_node_type_e
	 @param   OUT   nDepNodeNum						节点下 节点/通道/设备的数目
	 @return  函数返回错误类型，参考dpsdk_retval_e 
	 @remark 
	*/
	static public native  int DPSDK_GetLogicDepNodeNum(int nPDLLHandle, byte szDepCoding[], int nNodeType, Return_Value_Info_t nDepNodeNum);	

	/** 获取业务树指定节点下 节点信息
	 @param   IN	nPDLLHandle						SDK句柄
	 @param   IN    szDepCoding						节点Coding
	 @param   IN    nIndex							序号
	 @param   OUT   depInfoEx						组织节点信息
	 @return  函数返回错误类型，参考dpsdk_retval_e 
	 @remark    
	*/
	static public native  int DPSDK_GetLogicSubDepInfoByIndex(int nPDLLHandle, byte szDepCoding[], int nIndex, Dep_Info_Ex_t depInfoEx);	
	
	/** 获取业务树指定节点下 设备或者通道ID
	@param   IN		nPDLLHandle						SDK句柄
	@param   IN		szDepCoding						节点Coding
	@param   IN		nIndex							序号
	@param   IN		bChnl							=true 为通道，否则是设备
	@param   OUT	szCodeID						节点ID
	@return  函数返回错误类型，参考dpsdk_retval_e 
	@remark     
	*/
	static public native  int DPSDK_GetLogicID(int nPDLLHandle, byte szDepCoding[], int nIndex, boolean bChnl, Return_Value_ByteArray_t szCodeID);
	
	/** 获取实况码流.
	 @param   IN	nPDLLHandle				SDK句柄
	 @param   OUT	nRealSeq				码流请求序号,可作为后续操作标识 
	 @param   IN	getInfo					码流请求信息 
	 @param   IN    cbMediaDataCallback		码流回调函数				
	 @param   IN	nTimeout				超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native  int DPSDK_GetRealStream( int nPDLLHandle, Return_Value_Info_t nRealSeq, Get_RealStream_Info_t getInfo, fMediaDataCallback cbMediaDataCallback, int nTimeout );
	
	/** 按请求序号关闭码流.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	nRealSeq		码流请求序号
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native  int DPSDK_CloseRealStreamBySeq( int nPDLLHandle, int nRealSeq, int nTimeout );
	

	/** 获取语音码流
	 @param   IN	nPDLLHandle				SDK句柄
	 @param   OUT	nTalkSeq				码流请求序号,可作为后续操作标识 
	 @param   IN	getInfo					码流请求信息 
	 @param   IN    cbMediaDataCallback		码流回调函数				
	 @param   IN	nTimeout				超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native  int DPSDK_GetTalkStream( int nPDLLHandle, Return_Value_Info_t nTalkSeq, Get_TalkStream_Info_t getInfo, fMediaDataCallback cbMediaDataCallback, int nTimeout);
	
	/** 按请求序列停止语音码流的获取
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	nRealSeq		码流请求序号,可作为后续操作标识 
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native  int DPSDK_CloseTalkStreamBySeq( int nPDLLHandle, int nRealSeq, int nTimeout );
	
	
	/** 按CameralId停止语音码流获取.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	szCameraId		通道编号 
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native  int DPSDK_CloseTalkStreamByCameralId( int nPDLLHandle, byte szCameraId[], int nTimeout );

	/** 获取语音采集回调信息
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   OUT	audioFunInfo	语音采集回调信息
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native  int DPSDK_GetSdkAudioCallbackInfo(int nPDLLHandle, Audio_Fun_Info_t audioFunInfo);
	
	/** 向设备端发送语音采集数据
	 @param   IN	nPDLLHandle			SDK句柄
	 @param   OUT	sendAudioDataInfo	语音采集数据
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native  int DPSDK_SendAudioData(int nPDLLHandle, Send_Audio_Data_Info_t sendAudioDataInfo);	

	/** 查询录像.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	queryInfo		查询信息
	 @param   OUT	nRecordCount	录像记录个数
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	   1、nRecordCount最大5000个记录
	*/
	static public native  int DPSDK_QueryRecord( int nPDLLHandle, Query_Record_Info_t queryInfo, Return_Value_Info_t nRecordCount, int nTimeout);

	/** 通过码流类型查询录像.
	 @param   IN	nPDLLHandle				SDK句柄
	 @param   IN	queryInfo				查询信息
	 @param   IN	nStreamType				码流类型,请参考dpsdk_stream_type_e
	 @param   OUT	nRecordCount			录像记录个数
	 @param   IN	nTimeout				超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	   1、nRecordCount最大5000个记录
	*/
	static public native  int DPSDK_QueryRecordByStreamType( int nPDLLHandle, Query_Record_Info_t queryInfo, int nStreamType, Return_Value_Info_t nRecordCount, int nTimeout);
	
	
	/** 获取录像信息.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   OUT	pRecords		录像信息
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	   1、必须先查询后获取
	   2、DPSDK_QueryRecord会返回记录个数,
	*/
	static public native  int DPSDK_GetRecordInfo( int nPDLLHandle, Record_Info_t pRecords );

	/** 按文件请求录像流.
	 @param	  IN	nPDLLHandle				SDK句柄
	 @param   OUT	nPlaybackSeq			回放请求序号,作为后续操作标识  
	 @param	  IN	recordInfo				录像信息 
	 @param   IN    cbMediaDataCallback		码流回调函数				
	 @param   IN	nTimeout				超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native  int DPSDK_GetRecordStreamByFile( int nPDLLHandle, Return_Value_Info_t nPlaybackSeq, Get_RecordStream_File_Info_t recordInfo, fMediaDataCallback cbMediaDataCallback, int nTimeout );

	/** 按时间请求录像流.
	 @param	  IN	nPDLLHandle				SDK句柄
	 @param   OUT	nPlaybackSeq			回放请求序号,作为后续操作标识  
	 @param	  IN	recordInfo				录像信息 
	 @param   IN    cbMediaDataCallback		码流回调函数				
	 @param   IN	nTimeout				超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native int DPSDK_GetRecordStreamByTime( int nPDLLHandle, Return_Value_Info_t nPlaybackSeq, Get_RecordStream_Time_Info_t recordInfo, fMediaDataCallback cbMediaDataCallback, int nTimeout);

	/** 根据码流类型按时间请求录像流.
	 @param	  IN	nPDLLHandle					SDK句柄
	 @param   OUT	nPlaybackSeq				回放请求序号,作为后续操作标识  
	 @param	  IN	recordInfo					录像信息
	 @param   IN	nStreamType					码流类型,请参考dpsdk_stream_type_e
	 @param   IN    cbMediaDataCallback			码流回调函数				
	 @param   IN	nTimeout					超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native int DPSDK_GetRecordStreamByStreamType( int nPDLLHandle, Return_Value_Info_t nPlaybackSeq, Get_RecordStream_Time_Info_t recordInfo, int nStreamType, fMediaDataCallback cbMediaDataCallback, int nTimeout );	
	
	/** 暂停录像流.
	 @param	  IN	nPDLLHandle		SDK句柄
	 @param   IN	nPlaybackSeq	回放请求序号 
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native  int DPSDK_PauseRecordStreamBySeq( int nPDLLHandle, int nPlaybackSeq, int nTimeout);
	

	/** 恢复录像流.
	 @param	  IN	nPDLLHandle		SDK句柄
	 @param   IN	nPlaybackSeq	回放请求序号 
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native  int DPSDK_ResumeRecordStreamBySeq( int nPDLLHandle, int nPlaybackSeq, int nTimeout );

	/** 设置录像流速率.
	 @param	  IN	nPDLLHandle		SDK句柄
	 @param   IN	nPlaybackSeq	回放请求序号 
	 @param   IN    nSpeed,         录像流回放速度
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native  int DPSDK_SetRecordStreamSpeed( int nPDLLHandle, int nPlaybackSeq, int nSpeed, int nTimeout);

	/** 定位回放.
	 @param	  IN	nPDLLHandle		SDK句柄
	 @param   IN	nPlaybackSeq	回放请求序号 
	 @param   IN    lSeekBegin,		定位起始值.文件模式时,是定位处的文件大小值;时间模式时,是定位处的时间值;
	 @param   IN    lSeekEnd,		定位结束值.文件模式时,无意义;时间模式时,是期待的结束时间.
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark 
				lSeekBegin在文件模式下的计算方式可以是:(文件大小值)/100*(定位处相对文件的百分比)  
	*/
	static public native  int  DPSDK_SeekRecordStreamBySeq(int nPDLLHandle, int nPlaybackSeq, long lSeekBegin, long lSeekEnd, int nTimeout);

	/** 关闭录像流.
	 @param	  IN	nPDLLHandle		SDK句柄
	 @param   IN	nPlaybackSeq	回放请求序号 
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native  int DPSDK_CloseRecordStreamBySeq( int nPDLLHandle, int nPlaybackSeq, int nTimeout );

	/** 按通道关闭录像流.
	 @param	  IN	nPDLLHandle		SDK句柄
	 @param   IN	szCameraId   	通道编号 
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native  int DPSDK_CloseRecordStreamByCameraId( int nPDLLHandle, byte szCameraId[], int nTimeout );

	/** 云台方向控制.
	 @param	  IN	nPDLLHandle		SDK句柄
	 @param   IN	directInfo		云台方向控制信息 
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native  int DPSDK_PtzDirection( int nPDLLHandle, Ptz_Direct_Info_t directInfo, int nTimeout);

	/** 云台镜头控制.
	 @param	  IN	nPDLLHandle		SDK句柄
	 @param   IN	operationInfo	云台镜头控制信息 
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native  int DPSDK_PtzCameraOperation( int nPDLLHandle, Ptz_Operation_Info_t operationInfo, int nTimeout);


	/** 云台三维定位.
	 @param	  IN	nPDLLHandle		SDK句柄
	 @param   IN	sitInfo			云台三维定位信息 
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native  int DPSDK_PtzSit( int nPDLLHandle, Ptz_Sit_Info_t sitInfo, int nTimeout);

	/** 云台锁定控制.
	 @param	  IN	nPDLLHandle			SDK句柄
	 @param   IN	lockInfo	    	云台锁定控制信息
	 @param   IN	nTimeout			超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native  int DPSDK_PtzLockCamera( int nPDLLHandle, Ptz_Lock_Info_t lockInfo, int nTimeout);

	/** 云台灯光控制.
	 @param	  IN	nPDLLHandle			SDK句柄
	 @param	  IN	ptzOpenCmdInfo		云台灯光控制 
	 @param   IN	nTimeout			超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native  int DPSDK_PtzLightControl( int nPDLLHandle, Ptz_Open_Command_Info_t ptzOpenCmdInfo, int nTimeout );

	/** 云台雨刷控制.
	 @param	  IN	nPDLLHandle			SDK句柄
	 @param	  IN	ptzOpenCmdInfo		云台雨刷控制
	 @param   IN	nTimeout			超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native  int DPSDK_PtzRainBrushControl( int nPDLLHandle, Ptz_Open_Command_Info_t ptzOpenCmdInfo, int nTimeout);

	/** 云台红外控制.
	 @param	  IN	nPDLLHandle			SDK句柄
	 @param	  IN	ptzOpenCmdInfo		云台红外控制 
	 @param   IN	nTimeout			超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native  int DPSDK_PtzInfraredControl( int nPDLLHandle, Ptz_Open_Command_Info_t ptzOpenCmdInfo, int nTimeout );

	/** 云台查询预置点信息.
	 @param	  IN	nPDLLHandle			SDK句柄
	 @param	  INOUT	prePointInfo		预置点信息 
	 @param   IN	nTimeout			超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native  int DPSDK_QueryPrePoint( int nPDLLHandle, Ptz_Prepoint_Info_t prePointInfo, int nTimeout);

	/** 云台预置点操作.
	 @param	  IN	nPDLLHandle				SDK句柄
	 @param   IN	prePointOperation		预置点操作信息
	 @param   IN	nTimeout				超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native  int DPSDK_PtzPrePointOperation( int nPDLLHandle, Ptz_Prepoint_Operation_Info_t prePointOperation, int nTimeout );

	/** 云台扩展命令.
	 @param	  IN	nPDLLHandle			SDK句柄
	 @param	  IN	ptzExtCmd			扩展命令信息 
	 @param   IN	nTimeout			超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native  int DPSDK_PtzExtendCommand( int nPDLLHandle, Ptz_Extend_Command_Info_t ptzExtCmd, int nTimeout );
	
	/** 获取设备列表信息长度.
	 @param   IN	nPDLLHandle			SDK句柄
	 @param   OUT	nDevListLen       	设备列表信息长度
	 @param   IN	nTimeout			超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	*/
	static public native int DPSDK_GetDeviceListLen(int nPDLLHandle, Return_Value_Info_t nDevListLen, int nTimeout);

	/** 获取设备列表信息.
	 @param   IN	nPDLLHandle			SDK句柄
	 @param   OUT	szDevList       	设备列表xml字符串
	 @param   IN	nDevListLen       	设备列表信息长度
	 @param   IN	nTimeout			超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	     1、需要2次函数调用才能最终获取设备列表信息。
	     2、先使用DPSDK_GetDeviceListLen，获取nDevListLen的值。
		 3、获取到nDevListLen的值之后，创建一个长度为（nDevListLen+1）的char数组，并作为参数szDevList传入。
	*/
	static public native int DPSDK_GetDeviceListStr(int nPDLLHandle, byte szDevList[], int nDevListLen, int nTimeout);

	/** 获取所有设备详细信息长度.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   OUT   nDevInfoLen     需要查询的多个设备详细信息组成的xml字符串的长度
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	*/
	static public native int DPSDK_GetDevicesInfoLen(int nPDLLHandle, Return_Value_Info_t nDevInfoLen);

	/** 获取所有设备详细信息.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   OUT	szDevicesInfo   需要查询的多个设备详细信息组成的xml字符串
	 @param   IN	nDevInfoLen     设备详细信息组成的xml字符串的长度
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	     1、需要2次函数调用才能最终获取设备列表信息。
	     2、先使用DPSDK_GetDevicesInfoLen获取nDevicesCount的值。
		 3、获取到nDevicesCount的值之后，创建一个长度为（nDevicesCount+1）的char数组，并作为参数szDevicesInfo传入。
	*/
	static public native int DPSDK_GetDevicesInfoStr(int nPDLLHandle, byte szDevicesInfo[], int nDevInfoLen);
	
	/** 从服务器获取设备信息.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	szDeviceId		设备ID
	 @param   OUT   deviceInfoEx   	设备信息
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	*/
	static public native int DPSDK_GetDeviceInfoFromService( int nPDLLHandle, byte szDeviceId[], Device_Info_Ex_t deviceInfoEx, int nTimeout );
	
	/** 语音对讲失败后参数回调.
	 @param   IN    nPDLLHandle     SDK句柄
	 @param   IN    fun             回调函数
	 @param   IN    pUser           用户参数
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native int DPSDK_SetDPSDKTalkParamCallback(int nPDLLHandle, fDPSDKTalkParamCallback fun);
	
	/** 根据CemeraId获取通道状态，不支持NVR通道状态获取
	@param   IN    nPDLLHandle     SDK句柄
	@param   IN    szCameraId      通道ID
	@param   OUT   nStatus         状态值，参见dpsdk_dev_status_e
	@return  函数返回错误类型，参考dpsdk_retval_e
	@remark 
	*/
	static public native int DPSDK_GetChannelStatus(int nPDLLHanle,  byte szCameraId[], Return_Value_Info_t nStatus);

	/** 根据设备ID获取设备类型
	@param   IN    nPDLLHandle     SDK句柄
	@param   IN    szDevId		   设备ID
	@param   OUT   nDeviceType     设备类型
	@return  函数返回错误类型，参考dpsdk_retval_e
	@remark 
	*/
	static public native int DPSDK_GetDeviceTypeByDevId(int nPDLLHandle, byte szDevId[], Return_Value_Info_t nDeviceType);
	
	/** 视频报警主机布撤防旁路.
	 @param   IN    nPDLLHandle     SDK句柄
	 @param   IN    szDeviceId      设备id
	 @param   IN    channelId       通道号，-1表示对设备操作
	 @param   IN    controlType     操作类型, 参考dpsdk_AlarmhostOperator_e
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  视频报警主机类型为:1101
	*/
	static public native int DPSDK_ControlVideoAlarmHost(int nPDLLHandle, byte szDeviceId[], int channelId, int controlType, int nTimeout);
	
	/** 网络报警主机布撤防旁路.
	 @param   IN    nPDLLHandle     SDK句柄
	 @param   IN    szId			设备id/通道id
	 @param   IN    opttype			设备/通道操作,参考dpsdk_netalarmhost_operator_e
	 @param   IN    controlType     操作类型, 参考dpsdk_netalarmhost_controltype_e
	 @param   IN    iStart			开始时间,默认为0
	 @param   IN    iEnd			结束时间,默认为0
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  网络报警主机类型为:601
	*/
	static public native int DPSDK_ControlNetAlarmHostCmd(int nPDLLHandle, byte szId[], int opttype, int controlType, long iStart, long iEnd, int nTimeout);

	/** 设置远程设备抓图回调
	*/
	static public native int DPSDK_SetDPSDKRemoteDeviceSnapCallback(int nPDLLHandle, fDPSDKRemoteDeviceSnapCallback fun);

	/**通过Json协议发送命令给cms.
	@param   IN    nPDLLHandle		SDK句柄
	@param   IN    szJson			Json字符串,
	形如:"{ \"DevID\": \"1000000\",\"CameraId\":\"1000000$1$0$1\", \"DevChannel\": 1,\"PicNum\": 1,\"CourtTime\": \"2014-09-17 16:00:00\"}"
	@param   OUT   szJsonResult		平台返回的Json字符串,
	@return  函数返回错误类型，参考dpsdk_retval_e
	@remark 
	*/
	static public native int DPSDK_SendCammandToCMSByJson(int nPDLLHandle, byte[] szJson, byte[] szJsonResult, int nTimeout);

	/**通过Json协议发送命令给DMS.
	@param   IN    nPDLLHandle		SDK句柄
	@param   IN    szJson			Json字符串,
	形如:"{ \"DevID\": \"1000000\",\"CameraId\":\"1000000$1$0$1\", \"DevChannel\": 1,\"PicNum\": 1,\"CourtTime\": \"2014-09-17 16:00:00\"}"
	@param   IN    szCamId			Json字符串,
	@param   OUT   szJsonResult		平台返回的Json字符串,
	@return  函数返回错误类型，参考dpsdk_retval_e
	@remark 
	*/
	static public native int DPSDK_SendCammandToDMSByJson(int nPDLLHandle, byte[] szJson, byte[] szCamId, byte[] szJsonResult, int nTimeout);

	/** 获取用户详情.以后有关用户的信息都在DPSDK_UserInfo_t里面增加
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   OUT	userInfo		用户信息结构体
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native int DPSDK_GetUserInfo(int nPDLLHandle, DPSDK_UserInfo_t userInfo, int nTimeout);

	/** 根据设备ID获取报警输入通道信息
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   OUT	alarmInChnlInfo	用户信息结构体
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	 1、alarmInChnlInfo需要在外面创建好
	 2、alarmInChnlInfo的个数与DPSDK_GetDGroupInfo返回时有报警主机设备id和报警输入通道个数
	*/
	static public native int DPSDK_GetAlarmInChannelInfo(int nPDLLHandle, Get_AlarmInChannel_Info_t alarmInChnlInfo);

	/** 查询网络报警主机状态
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	szDeviceId		设备id
	 @param   IN	nChannelcount	通道个数
	 @param   OUT	defenceStatus	通道信息结构体
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	 1、defenceStatus需要在外面创建好，根据通道个数new
	*/
	static public native int DPSDK_QueryNetAlarmHostStatus(int nPDLLHandle, byte[] szDeviceId, int nChannelcount, dpsdk_AHostDefenceStatus_t[] defenceStatus, int nTimeout);

	/** 设置视频报警主机布撤防/旁路状态回调.
	 @param   IN    nPDLLHandle     SDK句柄
	 @param   IN    fun             回调函数
	 @param   IN    pUser           用户参数
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native int DPSDK_SetVideoAlarmHostStatusCallback(int nPDLLHandle, fDPSDKVideoAlarmHostStatusCallback fun);

	/** 设置网络报警主机布撤防/旁路状态回调.
	 @param   IN    nPDLLHandle     SDK句柄
	 @param   IN    fun             回调函数
	 @param   IN    pUser           用户参数
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native int DPSDK_SetNetAlarmHostStatusCallback(int nPDLLHandle, fDPSDKNetAlarmHostStatusCallback fun);

	/** 报警订阅设置-报警运营平台.
	 @param   IN    nPDLLHandle     SDK句柄
	 @param   IN    userParam       用户参数
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native int DPSDK_PhoneSubscribeAlarm(int nPDLLHandle, dpsdk_phone_subscribe_alarm_t userParam, Return_Value_Info_t nIsSubscribe, int nTimeout);

	/** 报警布控.
	 @param	  IN	nPDLLHandle		SDK句柄
	 @param	  IN	sourceInfo		报警方案 
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	 1、布控时需要明白不同的报警类型对应不同的参数
	*/
	static public native int DPSDK_EnableAlarm(int nPDLLHandle, Alarm_Enable_Info_t sourceInfo, int nTimeout);

	/** 报警布控(针对某个部门下的所有设备)
	 @param	  IN	nPDLLHandle		SDK句柄
	 @param	  IN	sourceInfo		报警方案 
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	 1、布控时需要明白不同的报警类型对应不同的参数
	*/
	static public native int DPSDK_EnableAlarmByDepartment(int nPDLLHandle, Alarm_Enable_By_Dep_Info_t sourceInfo, int nTimeout);

	/** 报警撤控.
	 @param	  IN	nPDLLHandle		SDK句柄
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native int DPSDK_DisableAlarm(int nPDLLHandle, int nTimeout);
	
	/** 设置收到别人分享视频消息后的回调函数
	@param   IN    nPDLLHandle     SDK句柄
	@param   IN    fun             回调函数
	@param   IN    pUser           用户参数
	@return  函数返回错误类型，参考dpsdk_retval_e
	@remark 
	*/
	static public native int DPSDK_SetShareVideoCallback(int nPDLLHandle, fDPSDKShareVideoCallback fun);
	
	/** 分享视频
	@param   IN    nPDLLHandle		SDK句柄
	@param   IN    videoInfoArray	分享的视频信息结构数组
	@param   IN    userIdArray		分享对象用户ID数组
	@param   IN    szMsg			附加的信息
	@return  函数返回错误类型，参考dpsdk_retval_e
	@remark 
	*/
	static public native int DPSDK_ShareVideo(int nPDLLHanle, ShareVideoInfo videoInfoArray[], int userIdArray[], byte[] szMsg, int nTimeout);
	
	/** 获取用户组织信息字符串
	@param  IN		nPDLLHandle     SDK句柄
	@param  OUT		szOrgInfo		用户组织信息
	@return	
	*/
	static public native int DPSDK_GetUserOrgInfo(int nPDLLHandle, GetUserOrgInfo userOrgInfo, int nTimeout);
	
	/** 设置Json协议回调.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	fun				回调函数
	 @return  函数返回错误类型，参考{@link dpsdk_retval_e}	
	*/
	static public native int DPSDK_SetGeneralJsonTransportCallback(int nPDLLHandle, fDPSDKGeneralJsonTransportCallback fun);
	
	/**通过Json协议发送命令,返回结果通过DPSDK_SetGeneralJsonTransportCallback回调
	 @param   IN    nPDLLHandle		SDK句柄
	 @param   IN    szJson			Json字符串,
	 @param   IN    mdltype			模块,参考dpsdk_mdl_type_e
	 @param   IN    trantype		JSON 传输类型,参考generaljson_trantype_e
	 @param   IN    nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考{@link dpsdk_retval_e}
	*/
	static public native int DPSDK_GeneralJsonTransport(int nPDLLHandle, byte[] szJson, int mdltype, int trantype, int nTimeout);
	
	/** 获取报警预案数量
	 @param   IN    nPDLLHandle		SDK句柄
	 @param   OUT   nCount			报警预案数量
	 @param   IN	nTimeout		超时时间
	 @return  函数返回错误类型，参考{@link dpsdk_retval_e}
	 @sample
		 Return_Value_Info_t nCount = new Return_Value_Info_t();
		 IDpsdkCore.DPSDK_GetAlarmSchemeCount(m_nPDLLHandle, nCount, dpsdk_constant_value.DPSDK_CORE_DEFAULT_TIMEOUT);
		 int nAlarmCount = nCount.nReturnValue;
	*/
	static public native int DPSDK_GetAlarmSchemeCount(int nPDLLHandle, Return_Value_Info_t nCount, int nTimeout);


	/** 获取报警预案列表
	 @param		IN		nPDLLHandle			SDK句柄
	 @param		OUT		alarmSchemeList		报警预案
	 @param		IN		nTimeout			超时时间
	 @return	函数返回错误类型，参考dpsdk_retval_e
	 @sample
		 Return_Value_Info_t nCount = new Return_Value_Info_t();
		 IDpsdkCore.DPSDK_GetAlarmSchemeCount(m_nPDLLHandle, nCount, dpsdk_constant_value.DPSDK_CORE_DEFAULT_TIMEOUT);
		 int nAlarmCount = nCount.nReturnValue;
		 if (nAlarmCount > 0)
		 {
		 	AlarmSchemeInfo_t[] alarmSchemeList = new AlarmSchemeInfo_t[nAlarmCount];
		 	IDpsdkCore.DPSDK_GetAlarmSchemeList(m_nPDLLHandle, alarmSchemeList, dpsdk_constant_value.DPSDK_CORE_DEFAULT_TIMEOUT);
		 	for (int i = 0; i < alarmSchemeList.length; ++i)
		 	{
		 		//do something
		 	}
		 }
	*/
	static public native int DPSDK_GetAlarmSchemeList(int nPDLLHandle, AlarmSchemeInfo_t[] alarmSchemeList, int nTimeout);

	/** 保存报警预案
	 @param		IN		nPDLLHandle			SDK句柄
	 @param		IN		alarmScheme			报警预案
	 @param		IN		nTimeout			超时时间
	 @return	函数返回错误类型，参考{@link dpsdk_retval_e}
	 	 @sample
		 Return_Value_Info_t nCount = new Return_Value_Info_t();
		 IDpsdkCore.DPSDK_GetAlarmSchemeCount(m_nPDLLHandle, nCount, dpsdk_constant_value.DPSDK_CORE_DEFAULT_TIMEOUT);
		 int nAlarmCount = nCount.nReturnValue;
		 if (nAlarmCount > 0)
		 {
		 	AlarmSchemeInfo_t[] alarmSchemeList = new AlarmSchemeInfo_t[nAlarmCount];
		 	IDpsdkCore.DPSDK_GetAlarmSchemeList(m_nPDLLHandle, alarmSchemeList, dpsdk_constant_value.DPSDK_CORE_DEFAULT_TIMEOUT);
		 	for (int i = 0; i < alarmSchemeList.length; ++i)
		 	{
		 		alarmSchemeList[i].status = dpsdk_alarmScheme_status_e.ALARM_SCHEME_STATUS_OPEN;
		 		IDpsdkCore.DPSDK_SaveAlarmScheme(m_nPDLLHandle, alarmSchemeList[i], dpsdk_constant_value.DPSDK_CORE_DEFAULT_TIMEOUT);
		 	}
		 }
	*/
	static public native int DPSDK_SaveAlarmScheme(int nPDLLHandle, AlarmSchemeInfo_t alarmScheme, int nTimeout);
	
	/** 发送消息给scs服务
	 @param		IN		nPDLLHandle			SDK句柄
	 @param		IN		szGroupId			呼叫组ID
	 @param		IN		szStrText			发送的文本内容
	 @param		IN		nTimeout			超时时间
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @sample
		DPSDK_SendScsMsg(m_nPDLLHandle, "test".getBytes(), "test".getBytes(), dpsdk_constant_value.DPSDK_CORE_DEFAULT_TIMEOUT);
	*/
	static public native int DPSDK_SendScsMsg(int nPDLLHandle, byte[] szGroupId, byte[] szStrText, int nTimeout);
	
	/** 开始广播（获取广播语音码流）
	@param   IN  nPDLLHandle           SDK句柄
	@param   OUT nReturnValue      码流请求序号,可作为后续操作标识
	@param   IN  bJson             码流请求信息
	@param   IN  bFun            码流回调函数       
	@param   IN  nTimeout          超时时长，单位毫秒
	@return  函数返回错误类型，参考dpsdk_retval_e
	@remark      
	*/

	static public native int DPSDK_StartBroadcast(int nPDLLHandle, Return_Value_Info_t nReturnValue, byte[] bJson, fMediaDataCallback bFun, int nTimeout);
	
	/** 关闭广播
	@param   IN  nPDLLHandle      SDK句柄
	@param   IN  nTalkSeq     码流请求序号
	@param   IN  bJson        请求信息
	@param   IN  nTimeout     超时时长，单位毫秒
	@return  函数返回错误类型，参考dpsdk_retval_e
	@remark      
	*/
	static public native int  DPSDK_CloseBroadcastStream(int nPDLLHandle, int nTalkSeq, byte[] bJson, int nTimeout);
	
	/** 根据通道ID获取设备ID.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	szChanId		通道编号
	 @param   OUT	szDevId			设备编号
	 @return  函数返回错误类型，参考dpsdk_retval_e
	*/
	static public native int DPSDK_GetDevIdByChnId(int nPDLLHandle, byte[] szChanId, byte[] szDevId);
	
	/** 设置DPSDK参数.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	DPSDKParam_t	参数
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark									
	*/
	static public native int DPSDK_SetParam(int nPDLLHandle, DPSDKParam_t dpsdkParam);
	
	/** 获取收藏夹xml长度.
	 @param   IN	nPDLLHandle		SDK句柄
	  @param   int	nDepInfoAllLen	收藏夹信息
	 @param		IN		nTimeout			超时时间
	 @return  函数返回错误类型，参考dpsdk_retval_e	
	*/
	static public native int DPSDK_GetFavoriteLen(int nPDLLHandle, Return_Value_Info_t nDepInfoAllLen, int nTimeout);

	/** 获取收藏夹.
	 @param   IN	nPDLLHandle		SDK句柄
	  @param   OUT	szDepInfoAll	收藏夹信息
	 @param		IN		nTimeout			超时时间
	 @return  函数返回错误类型，参考dpsdk_retval_e	
	*/
	static public native int DPSDK_GetFavorite(int nPDLLHandle, byte[] szDepInfoAll, int nLen, int nTimeout);

	/** 保存收藏夹.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	szDepInfoAll	收藏夹信息
	 @param		IN		nTimeout			超时时间
	 @return  函数返回错误类型，参考dpsdk_retval_e	
	*/
	static public native int DPSDK_SaveFavorite(int nPDLLHandle, byte[] szDepInfoAll, int nTimeout);
	
	/** 用户数据变更回调.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	fun				回调函数
	 @return  函数返回错误类型，参考dpsdk_retval_e	
	*/
	static public native int DPSDK_SetUserDataChangeCallback(int nPDLLHandle, 
			fDPSDKUserDataChangeCallback fun);
	
	/** 获取组织下编码器通道的信息.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   INOUT	pGetInfo		子通道信息
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	 1、pEncChannelnfo需要在外面创建好
	 2、pEncChannelnfo的大小与DPSDK_GetDGroupInfo中通道个数返回需要一致
	 */
	static public native int DPSDK_GetDepChannelInfo(int nPDLLHandle, Get_Dep_Channel_Info_t getDepChnlInfo);

	/** 根据设备ID获取设备信息
	@param   IN    nPDLLHandle     SDK句柄
	@param   IN    szDevId		   设备ID
	@param   OUT   pDeviceInfoEx   设备信息
	@return  函数返回错误类型，参考dpsdk_retval_e
	@remark 
	*/
	static public native int DPSDK_GetDeviceInfoExById(int nPDLLHanle,  byte[] szDevId, Device_Info_Ex_t deviceInfoEx);
	
	/** 查询NVR通道状态
	@param   IN    nPDLLHandle     SDK句柄
	@param   IN    deviceId	       设备的ID
	@return  函数返回错误类型，参考dpsdk_retval_e
	@remark 
	*/
	static public native int DPSDK_QueryNVRChnlStatus(int nPDLLHandle, byte[] deviceId, int nTimeout);

	/** 设置NVR通道状态回调
	@param   IN	nPDLLHandle		SDK句柄
	@param   IN	fun				回调函数
	@return  函数返回错误类型，参考dpsdk_retval_e
	@remark 通道状态变化的时候会推送
	*/
	static public native int DPSDK_SetDPSDKNVRChnlStatusCallback(int nPDLLHandle, fDPSDKNVRChnlStatusCallback nvrChnlStatusCallback);

	
	/** 门控制.
	 @param	  IN	nPDLLHandle		SDK句柄
	 @param	  IN	pRequest		请求信息
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native int DPSDK_SetDoorCmd(int nPDLLHandle, SetDoorCmd_Request_t pRequest, int nTimeout );
	
	/** 获取绑定视频资源.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   OUT	pResponce		绑定视频资源XML
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	 */
	static public native int DPSDK_QueryLinkResource( int nPDLLHandle, Return_Value_Info_t nLen, int nTimeout);

	/** 获取绑定视频资源.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   OUT	pResponce		绑定视频资源XML
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	 */
	static public native int DPSDK_GetLinkResource( int nPDLLHandle, GetLinkResource_Responce_t pResponce );
	
	/** 设置门禁开关状态上报回调
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	fun				回调函数
	 @param   IN	pUser			用户参数
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native int DPSDK_SetPecDoorStatusCallback(int nPDLLHandle, fDPSDKPecDoorStarusCallBack pFun);
	
	/** 获取语音发送函数指针
	@param   IN		nPDLLHandle		SDK句柄
	@param   OUT	audioFunInfo	语音采集回调信息
	@return  函数返回错误类型，参考dpsdk_retval_e
	@remark		
	*/
	static public native int DPSDK_GetAudioSendFunCallBack(	int nPDLLHandle, Audio_Fun_Info_t audioFunInfo);
	
	/** 发送语音采集数据(可视对讲专用)
	 @param   IN	nPDLLHandle			SDK句柄
	 @param   OUT	sendAudioDataInfo	语音采集数据
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native  int DPSDK_SendVtCallAudioData(int nPDLLHandle, Send_Audio_Data_Info_t sendAudioDataInfo);
	
	/** 设置可视对讲呼叫邀请参数回调
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	fun				回调函数
	 @param   IN	pUser			用户参数
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native int DPSDK_SetVtCallInviteCallback(int nPDLLHandle, fDPSDKInviteVtCallParamCallBack pFun);
	
	/** 设置响铃参数通知回调
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	fun				回调函数
	 @param   IN	pUser			用户参数
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native int DPSDK_SetRingCallback(int nPDLLHandle, fDPSDKRingInfoCallBack pFun);
	
	/** 设置可视对讲繁忙状态通知回调
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	fun				回调函数
	 @param   IN	pUser			用户参数
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native int DPSDK_SetBusyVtCallCallback(int nPDLLHandle, fDPSDKBusyVtCallCallBack pFun);
	
	/** 请求可视对讲
	 @param   IN	nPDLLHandle			SDK句柄
	 @param   OUT	audioSessionId		音频请求序号,用于关闭对讲
	 @param   OUT	videoSessionId		视频请求序号,用于关闭对讲
	 @param   OUT	nStartVtCallParm	应答参数，用于本地频频采集和关闭对讲
	 @param   IN	nCallType			呼叫类型 0单播；1组播；2可视对讲dpsdk_call_type_e
	 @param   IN	szUserId			呼叫者ID
	 @param   IN    pFun				码流回调函数				
	 @param   IN	nTimeout			超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native int DPSDK_StartVtCall(int nPDLLHandle, Return_Value_Info_t audioSessionId, Return_Value_Info_t videoSessionId, StartVtCallParam_t nStartVtCallParm,  int nCallType, byte[] szUserId, fMediaDataCallback funCB, int nTimeout);

	/** 发送取消可视对讲
	 @param   IN	nPDLLHandle			SDK句柄
	 @param   IN	szUserId			呼叫者ID
	 @param   IN	audioSessionId		语音请求序列号
	 @param   IN	videoSessionId		视频请求序列号
	 @param   IN    nCallId				呼叫ID			
	 @param   IN    m_dlgId				回话ID
	 @param   IN	nTimeout			超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native int DPSDK_SendCancelVtCall(int nPDLLHandle, byte[] szUserId, int audioSessionId, int videoSessionId, int callId, int dlgId, int nTimeout);
	
	/** 请求可视对讲成功后，停止可视对讲
	 @param   IN	nPDLLHandle			SDK句柄
	 @param   IN	szUserId			呼叫者ID
	 @param   IN	audioSessionId		语音请求序列号
	 @param   IN	videoSessionId		视频请求序列号
	 @param   IN    nCallId				呼叫ID			
	 @param   IN    m_dlgId				回话ID
	 @param   IN	nTimeout			超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native int DPSDK_StopVtCall(int nPDLLHandle, byte[] szUserId, int audioSessionId, int videoSessionId, int m_callId, int m_dlgId, int nTimeout);
	
	/** 接受可视对讲邀请
	 @param   IN	nPDLLHandle			SDK句柄
	 @param   OUT	audioSessionId		音频请求序号,用于关闭对讲
	 @param   OUT	videoSessionId		视频请求序号,用于关闭对讲
	 @param   IN	nInviteVtCallParam	对讲参数，由DPSDK_SetVtCallInviteCallback获取
	 @param   IN	nCallType			呼叫类型 0单播；1组播；2可视对讲
	 @param   IN    pFun				码流回调函数				
	 @param   IN	nTimeout			超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native int DPSDK_InviteVtCall(int nPDLLHandle, Return_Value_Info_t audioSessionId, Return_Value_Info_t videoSessionId, InviteVtCallParam_t nInviteVtCallParam, int nCallType, fMediaDataCallback funCB, int nTimeout);
	
	/** 接受邀请后，挂断可视对讲
	 @param   IN	nPDLLHandle			SDK句柄
	 @param   IN	szUserId			呼叫者ID
	 @param   IN	audioSessionId		语音请求序列号
	 @param   IN	videoSessionId		视频请求序列号
	 @param   IN    nTid				
	 @param   IN	nTimeout			超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native int DPSDK_ByeVtCall(int nPDLLHandle, byte[] szUserId, int audioSessionId, int videoSessionId, int nTid, int nTimeout);
	
	/** 拒绝可视对讲邀请
	 @param   IN	nPDLLHandle			SDK句柄
	 @param   IN	szUserId			呼叫者ID
	 @param   IN    nCallId				呼叫ID				
	 @param   IN    nTid				
	 @param   IN	nTimeout			超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native int DPSDK_SendRejectVtCall(int nPDLLHandle, byte[] szUserId, int nCallId, int dlgId, int nTid, int nTimeout);
	
	/** 拒绝可视对讲邀请
	 @param   IN	nPDLLHandle			SDK句柄
	 @param   IN	nSendjson			发送json
	 @param   OUT   nRecivejson			应答json								
	 @param   IN	nTimeout			超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native int DPSDK_sendVtCallInfo(int nPDLLHandle, byte[] nSendjson, byte[] nRecivejson, int nTimeout);
	
	/** 修改可视对讲状态
	 @param   IN	nPDLLHandle			SDK句柄
	 @param   IN	szUserId			呼叫者ID
	 @param   IN	nCallStatus			呼叫状态dpsdk_call_status_e
	 @param   IN	audioSessionId		语音请求序列号
	 @param   IN	videoSessionId		视频请求序列号		
	 @param   IN	nTimeout			超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark		
	*/
	static public native int DPSDK_ModifyVtCallStatus(int nPDLLHandle, byte[] szUserId,  int nCallStatus, int audioSessionId, int videoSessionId, int nTimeout);
	
	/** 查询服务列表，建立服务连接（不用加载组织结构也可以控制云台、接收报警、接收设备状态上报）
	@param   IN    nPDLLHandle     SDK句柄
	@return  函数返回错误类型，参考dpsdk_retval_e
	*/
	static public native int DPSDK_QueryServerList(int nPDLLHandle);
	
	/** 设置缓存组织树文件路径.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	szFilePath		文件路径,android默认为"/sdcard"
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	 1、szFilePath android默认为"/sdcard"
	*/
	static public native int DPSDK_SetSaveGroupFilePath( int nPDLLHandle, byte[] szFilePath );
	
	/**获取最新GPS信息XML串长度.
	@param		IN		nPDLLHandle				SDK句柄
	@param		OUT		nGpsXMLLen				GPS XML的长度
	@param		IN		nTimeout				超时时间
	@return  函数返回错误类型，参考dpsdk_retval_e
	@remark 
	*/
	static public native  int  DPSDK_AskForLastGpsStatusXMLStrCount(int nPDLLHandle, Return_Value_Info_t nGpsXMLLen, int nTimeout);

	/**获取最新GPS信息.
	@param		IN		nPDLLHandle				SDK句柄
	@param		OUT		LastGpsIStatus			GPS XML数据
	@param		IN		nGpsXMLLen				GPS XML的长度,DPSDK_AskForLastGpsStatusXMLStrCount的输出参数值
	@param		IN		nTimeout				超时时间
	@return  函数返回错误类型，参考dpsdk_retval_e
	@remark 
	*/
	static public native  int  DPSDK_AskForLastGpsStatusXMLStr(int nPDLLHandle, byte LastGpsIStatus[], int nGpsXMLLen);
	
	/** 发送报警到服务.
	 @param	  IN	nPDLLHandle		SDK句柄
	 @param	  IN    Client_Alarm_Info_t		报警信息
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native int DPSDK_SendAlarmToServer( int nPDLLHandle, Client_Alarm_Info_t bDstEnable,int nTimeout);
	
	/** 设置卡口过车信息（不带图片）上报回调.
	 @param   IN    nPDLLHandle     SDK句柄
	 @param   IN    fun             回调函数
	 @param   IN    pUser           用户参数
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  设置回调函数以后再订阅DPSDK_SubscribeBayCarInfo
	*/
	static public native int DPSDK_SetDPSDKGetBayCarInfoCallbackEx(int nPDLLHandle, fDPSDKGetBayCarInfoCallbackEx BayCarInfoCallback);
	
	/** 订阅卡口过车信息上报.
	 @param   IN    nPDLLHandle   SDK句柄
	 @param   IN    pGetInfo      订阅卡口过车信息上报请求信息，参考Subscribe_Bay_Car_Info_t
                              注意: 如果订阅通道数nChnlCount为0(pEncChannelnfo要置NULL)，
                              表示所有通道的过车数据都上报.
							  只有订阅以后picSDK的回调才能起作用。DPSDK_SetDPSDKGetBayCarInfoCallback才能回调给上层
	 @param   IN    nTimeout        超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark  
	*/
	static public native int DPSDK_SubscribeBayCarInfo(int nPDLLHandle, Subscribe_Bay_Car_Info_t pGetInfo,int nTimeout);
	
	/** 连接SCS 
	 @param	  IN	nPDLLHandle		SDK句柄
	 @param	  IN	szScsIp			服务IP地址
	 @param	  IN	nScsPort		服务端口号.
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	*/
	static public native int DPSDK_ConnectToSCS(int nPDLLHandle, byte szScsIp[], int nScsPort, int nTimeout);
	
	/** 查询当月有录像的日期.
	 @param   IN	nPDLLHandle		SDK句柄
	 @param   IN	szCameraId		通道编号
	 @param   IN	nSource			录像来源，1全部，2设备，3平台，参考dpsdk_recsource_type_e
	 @param   IN	nRecordType		录像类型，参考dpsdk_record_type_e
	 @param   IN	nData			日期（单位秒），可随意选择所要查询月份里的一个时间点，据1970年1月1日0时0分0秒的秒数
	 @param   OUT	szDays			有录像的天，以逗号隔开,0代表当天没有录像，1代表有录像。上层输入参数推荐days = new char[128];
	 @param   OUT	nDaysLen       	days字符串的长度
	 @param   IN	nTimeout		超时时长，单位毫秒
	 @return  函数返回错误类型，参考dpsdk_retval_e
	 @remark
	 1、szGroupBuf需要在外面创建好
	 2、szGroupBuf的大小与nGroupLen需要一致或者大于nGroupLen
	*/
	static public native  int DPSDK_QueryRecordDaysofTheMonth( int nPDLLHandle, byte szCameraId[], int nSource, int nRecordType, long nData, byte szDays[], Return_Value_Info_t nDaysLen, int nTimeout );

}
